rgw - Bug #10661

RGW swift API: Response header of POST request for object does not contain content-length and
x-trans-id headers

01/28/2015 05:56 AM - Ahmad Faheem

Status: Resolved % Done: 0%
Priority: Normal Spent time: 0.00 hour
Assignee: Dmytro Yurchenko

Category:

Target version:

Source: Q/A Affected Versions:

Tags: ceph-qa-suite:

Backport: hammer Pull request ID:
Regression: No Crash signature (v1):
Severity: 3 - minor Crash signature (v2):
Reviewed:

Description
Steps to reproduce:

1. swift post container

2. curl -i https://object.jiocloud.com:80/swift/vi/container/test -X PUT -H "X-Auth-Token: bOfc9e40be454205b290ea6768f2c1b2" -H
"content-length: 0"

3. curl -i https://object.jiocloud.com:80/swift/v1/container/test -X POST -H "X-Auth-Token: bOfc9e40be454205b290ea6768f2¢c1b2"

HTTP/1.1 202 Accepted

Date: Wed, 28 Jan 2015 05:50:23 GMT
Server: Apache/2.4.7 (Ubuntu)
Content-Type: application/octet-stream
Connection: close

Transfer-Encoding: chunked

in swift the response header returned is:
curl -i http://10.0.2.15:8080/v1/AUTH_b2419ea9588d49ddbd8c006b5eb199ff/container/test -X POST -H "X-Auth-Token:
b8d0bac45¢c7343ae84705ceab696809c"

HTTP/1.1 202 Accepted

Content-Length: 76

Content-Type: text/html; charset=UTF-8

X-Trans-Id: txf097d3b0fdee4b3d96457-0054c7ebb1
Date: Tue, 27 Jan 2015 19:49:06 GMT

Associated revisions

Revision fd0c612c - 02/27/2015 04:44 PM - Radoslaw Zarzynski
rgw: enforce Content-Length in response for POST on Swift cont/obj.
Fixes: #10661

Backport: hammer
Signed-off-by: Radoslaw Zarzynski <rzarzynski@mirantis.com>
Revision 2cb5d600 - 05/06/2015 11:18 AM - Radoslaw Zarzynski

rgw: enforce Content-Length in response for POST on Swift cont/obj.

Fixes: #10661

Backport: hammer

Signed-off-by: Radoslaw Zarzynski <rzarzynski@mirantis.com>

(cherry picked from commit fd0c612cf867d2e99e74820130357e63305970fb)

History

#1 - 02/04/2015 02:00 PM - Dmytro Yurchenko

The documentation seems to be a little bit controversial
http://docs.openstack.org/api/openstack-object-storage/1.0/content/POST_updateObjectMeta__v1__account _container __object _storage_object
_services.html

It says: Content-Length If the operation succeeds, this value is zero (0). If the operation fails, this value is the length of the error text in the response
body.

But at the same time both examples do not return Content-Length: 0 on success
curl -i $publicURL/marktwain/goodbye -X POST -H "X-Auth-Token: $token" -H "X-Object-Meta-Book: GoodbyeColumbus"
HTTP/1.1 202 Accepted
Content-Length: 76
Content-Type: text/html; charset=UTF-8
X-Trans-Id: txb5fb5c91ba1f4f37bb648-0052d84b3f
Date: Thu, 16 Jan 2014 21:12:31 GMT

<html><h1>Accepted</h1><p>The request is accepted for processing.</p></html>

curl -i $publicURL/marktwain/goodbye -X POST -H "X-Auth-Token: $token" -H "X-Object-Meta-Book: GoodbyeOldFriend"
HTTP/1.1 202 Accepted
Content-Length: 76
Content-Type: text/html; charset=UTF-8
X-Trans-Id: tx5ec7ab81cdb34ced887c8-0052d84ca4
Date: Thu, 16 Jan 2014 21:18:28 GMT

<html><h1>Accepted</h1><p>The request is accepted for processing.</p></html>

One thing is for sure, that Content-Length has to be present.

When | use built-in civetweb frontend:

$ curl -1 "http://localhost:8000/swift/v1/cont1/file1" -X POST -H "Content-Type: application/json" -H "X-Auth-Token: $token"
HTTP/1.1 202 Accepted

Content-type: text/plain; charset=utf-8
Content-Length: 0

$ curl -1 "http://localhost:8000/swift/v1/cont1/non-existent-file" -X POST -H "Content-Type: application/json" -H "X-Auth-Token: $token"

HTTP/1.1 404 Not Found
Content-Length: 9

Accept-Ranges: bytes

Content-type: text/plain; charset=utf-8
But when | use fcgi frontend behind nginx:
$ curl -l "http://localhost:8080/swift/v1/cont1/file1" -X POST -H "Content-Type: application/json" -H "X-Auth-Token: $token"

HTTP/1.1 202 Accepted

Server: nginx/1.4.6 (Ubuntu)

Date: Wed, 04 Feb 2015 13:46:59 GMT
Content-Type: text/plain; charset=utf-8
Transfer-Encoding: chunked
Connection: keep-alive

$ curl -1 "http://localhost:8080/swift/v1/cont1/non-existent-file" -X POST -H "Content-Type: application/json" -H "X-Auth-Token: $token"

HTTP/1.1 404 Not Found

Server: nginx/1.4.6 (Ubuntu)

Date: Wed, 04 Feb 2015 13:48:54 GMT
Content-Type: text/plain; charset=utf-8
Content-Length: 9

Connection: keep-alive
Accept-Ranges: bytes

It seems like nginx thinks "Content-Length: 0" is useless and threw it away while preserving content-length greater than 0.

Please, check if it is an issue caused by Apache.

#2 - 02/26/2015 01:50 PM - Dmytro Yurchenko

- Assignee set to Dmytro Yurchenko

Radoslaw Zarzynski is working on it.

#3 - 02/26/2015 01:59 PM - Radoslaw Zarzynski
I'm working on this issue.
After initial analysis it looks like the civetweb frontend generates the "Content-Length" header in behalf of the

RGWPutMetadata_ObjStore_ SWIFT::send_response(). Please refer the RGWMongoose::complete_header() and
RGWMongoose::complete_request() methods. The FCGI frontend lacks this feature.
#4 - 02/27/2015 11:52 AM - Radoslaw Zarzynski
Pull request: https://github.com/ceph/ceph/pull/3818.

#5 - 03/02/2015 06:55 PM - Yehuda Sadeh
- Status changed from New to Pending Backport

- Backport set to hammer

#6 - 05/06/2015 11:19 AM - Loic Dachary

e hammer backport https:/github.com/ceph/ceph/pull/4576

#7 - 05/12/2015 10:21 AM - Loic Dachary
- Status changed from Pending Backport to Resolved

- Regression set to No
